Package net.sf.saxon.expr.parser

## Class ContextItemStaticInfo

- java.lang.Object
- - net.sf.saxon.expr.parser.ContextItemStaticInfo

- Direct Known Subclasses:
    `ContextItemStaticInfoEE`

      public class ContextItemStaticInfo
      extends java.lang.Object

  A data structure that represents the required type of the context item, together with information about whether it is known to be present or absent or whether it is not known statically whether it is present or absent.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ContextItemStaticInfo` | `ABSENT` |
    `static ContextItemStaticInfo` | `DEFAULT` | Default information when nothing else is known

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ContextItemStaticInfo​(ItemType itemType, boolean maybeUndefined)` | Create a ContextItemStaticInfo

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `UType` | `getContextItemUType()` | Get the static type of the context item as a UType
    `Expression` | `getContextSettingExpression()` |
    `ItemType` | `getItemType()` | Get the static type of the context item.
    `boolean` | `isParentless()` |
    `boolean` | `isPossiblyAbsent()` | Ask whether it is possible that the context item is absent
    `boolean` | `isStrictStreamabilityRules()` |
    `void` | `setContextPostureGrounded()` | Set streaming posture.
    `void` | `setContextPostureStriding()` | Set streaming posture.
    `void` | `setContextSettingExpression​(Expression setter)` |
    `void` | `setParentless​(boolean parentless)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT

          public static final ContextItemStaticInfo DEFAULT

      Default information when nothing else is known

    - #### ABSENT

          public static final ContextItemStaticInfo ABSENT

  - ### Constructor Detail

    - #### ContextItemStaticInfo

          public ContextItemStaticInfo​(ItemType itemType,
                                       boolean maybeUndefined)

      Create a ContextItemStaticInfo
      Parameters:
        `itemType` - the item type of the context item. If the context item is absent, set this to `ErrorType.getInstance()`.
        `maybeUndefined` - set to true if it is possible (or certain) that the context item will be absent.

  - ### Method Detail

    - #### setContextSettingExpression

          public void setContextSettingExpression​(Expression setter)

    - #### getContextSettingExpression

          public Expression getContextSettingExpression()

    - #### getItemType

          public ItemType getItemType()

      Get the static type of the context item. If the context item is known to be undefined, the returned value is
      Returns:
        the static context item type

    - #### getContextItemUType

          public UType getContextItemUType()

      Get the static type of the context item as a UType
      Returns:
        the static context item type

    - #### isPossiblyAbsent

          public boolean isPossiblyAbsent()

      Ask whether it is possible that the context item is absent
      Returns:
        true if the context item might be absent

    - #### setContextPostureStriding

          public void setContextPostureStriding()

      Set streaming posture. The Saxon-HE version of this method has no effect.

    - #### setContextPostureGrounded

          public void setContextPostureGrounded()

      Set streaming posture. The Saxon-HE version of this method has no effect.

    - #### isStrictStreamabilityRules

          public boolean isStrictStreamabilityRules()

    - #### setParentless

          public void setParentless​(boolean parentless)

    - #### isParentless

          public boolean isParentless()